import 'ds_response_object.dart';

class DSResponseList<T> extends BaseResponse<List<T>> {
  DSResponseList(code, msg, data) : super(code, msg, data);

  factory DSResponseList.fromJson(jsonMap, DecodeFunction decodeFunction) =>
      $DSResponseListFromJson<T>(jsonMap, decodeFunction);

  Map<String, dynamic> toJson(EncodeFunction encodeFunction) =>
      $DSResponseListToJson<T>(this, encodeFunction);
}

DSResponseList<T> $DSResponseListFromJson<T>(
    Map<String, dynamic> jsonMap, DecodeFunction decodeFunction) {
  List<T> data = [];

  if (jsonMap['data'] != null) {
    if(jsonMap['data'] is List){
      data = List<T>.from((jsonMap['data'] as List).map((item) => decodeFunction(item)));
    }else if(jsonMap['data'] is Map){
      Map<String,dynamic> map = jsonMap['data'];
      if(map['list'] != null && map['list'] is List){
        data = List<T>.from((map['list'] as List).map((item) => decodeFunction(item)));
      }
    }
  }

  return DSResponseList<T>(
      jsonMap['code'] as int?,
      jsonMap['msg'] as String?, data);
}

Map<String, dynamic> $DSResponseListToJson<T>(
        DSResponseList<T> instance, EncodeFunction encodeFunction) =>
    <String, dynamic>{
      'code': instance.code,
      'msg': instance.msg,
      'data': instance.data.map((item) => encodeFunction(item)).toList()
    };