typedef DecodeFunction<T> = T Function(Map<String, dynamic>?);
typedef EncodeFunction<T> = Map<String, dynamic> Function(T?);

class DSResponseObject<T> extends BaseResponse<T?> {
  DSResponseObject(code, msg, data) : super(code, msg, data);

  factory DSResponseObject.fromJson(Map<String, dynamic> jsonMap, DecodeFunction<T> decodeFunction) => $DSResponseObjectFromJson<T>(jsonMap, decodeFunction);

  Map<String, dynamic> toJson(EncodeFunction<T> encodeFun) =>
      $DSResponseObjectToJson<T>(this, encodeFun);
}

DSResponseObject<T> $DSResponseObjectFromJson<T>(Map<String, dynamic> jsonMap, DecodeFunction<T> decodeFunction){
  int? code = jsonMap['code'] as int?;
  String? msg = jsonMap['msg'] as String?;
  dynamic data;
  if(jsonMap['data'] != null && jsonMap['data'] is Map){
    data = decodeFunction(jsonMap['data']);
  }
  return  DSResponseObject<T>(code,msg,data);
}

Map<String, dynamic> $DSResponseObjectToJson<T>(
        DSResponseObject<T> instance, EncodeFunction<T> encodeFunction) =>
    <String, dynamic>{
      'code': instance.code,
      'msg': instance.msg,
      'data': encodeFunction(instance.data)
    };

class BaseResponse<T> {
  final int? code;
  final String? msg;
  final T data;
  BaseResponse(this.code, this.msg, this.data);
  
  bool get isSuccess => code == 2000;
}